package de.szut.casino.blackjack;

import de.szut.casino.user.UserEntity;
import de.szut.casino.user.UserRepository;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Random;

@Service
public class BlackJackService {
    private final BlackJackGameRepository blackJackGameRepository;
    private final UserRepository userRepository;

    public BlackJackService(BlackJackGameRepository blackJackGameRepository, UserRepository userRepository) {
        this.blackJackGameRepository = blackJackGameRepository;
        this.userRepository = userRepository;
    }

    private final Random random = new Random();

    public BlackJackGameEntity createBlackJackGame(UserEntity user, BigDecimal betAmount) {
        BlackJackGameEntity game = new BlackJackGameEntity();
        game.setUser(user);
        game.setBet(betAmount);
        game.setState("IN_PROGRESS");

        for (int i = 0; i < 2; i++) {
            CardEntity playerCard = createRandomCard(game);
            game.getPlayerCards().add(playerCard);
        }

        CardEntity dealerCard = createRandomCard(game);
        game.getDealerCards().add(dealerCard);

        user.setBalance(user.getBalance().subtract(betAmount));

        userRepository.save(user);
        blackJackGameRepository.save(game);

        return game;
    }

    private CardEntity createRandomCard(BlackJackGameEntity game) {
        CardEntity card = new CardEntity();
        card.setGame(game);
        card.setSuit(Suit.values()[random.nextInt(Suit.values().length)]);
        card.setRank(Rank.values()[random.nextInt(Rank.values().length)]);
        return card;
    }
}
